<template>
  <div class="com-el-tree">
    <div class="role-list">
      <icon type="ios-people"></icon>角色列表
    </div>
    <el-scrollbar style="height:100%;  width: 180px;" class="el-role-tree">
      <el-tree
        :data="tree"
        @node-click="nodeClick"
        node-key="id"
        :default-expanded-keys="openKeys"
        :expand-on-click-node="false"
        style="padding:5px 0;margin-right: 2px;"
      >
        <div class="action-group" slot-scope="{  data }">
          <div
            class="action-text"
            :class="{actived:data.id==selectId,'node-text':data.parentId!==0}"
            :style="{width:((4-data.lv)*18+150)+'px'}"
          >
            <Icon
              v-if="data.parentId!==0"
              :type="data.id==selectId?'ios-paper':'ios-paper-outline'"
            />
            {{ data.roleName }}
          </div>
        </div>
      </el-tree>
    </el-scrollbar>
  </div>
</template>

<script>
export default {
  props: {
    // roles: {
    //   type: Object,
    //   default: () => {
    //     return [];
    //   }
    // },
    onChange: {
      type: Function,
      default: (treeId) => {},
    },
  },
  data() {
    return {
      selectId: -1,
      checked: false,
      openKeys: [],
      data: [],
      tree: [],
    };
  },
  created() {
    this.load();
  },
  methods: {
    load() {
      this.http.post("/api/role/getUserChildRoles", {}, true).then((result) => {
        if (!result.status) return this.$message.error(result.message);
        this.data.splice(0);
        this.data = result.data;
        this.data.forEach((x) => {
          if (x.parentId == 0) {
            x.lv = 1;
            x.children = [];
            this.tree.push(x);
            this.getTree(x.id, x);
          }
        });
        this.openKeys.push(this.tree[0].id);
        this.selectId = this.openKeys[0];
        //默认加载第一个树形菜单下面的数据

        //this.onChange(this.selectId);
      });
    },
    getTree(id, data) {
      this.data.forEach((x) => {
        if (x.parentId == id) {
          x.lv = data.lv + 1;
          if (!data.children) data.children = [];
          data.children.push(x);
          this.getTree(x.id, x);
        }
      });
    },
    nodeClick(node, selected) {
      //  console.log(node);
      this.selectId = node.id;
      //缓存当前选中的节点
      //  this.$store.getters.data().treeDemo1.treeId = node.id;
      this.onChange(node);
    },
  },
};
</script>
<style lang="less" scoped>
.com-el-tree {
  //2020.06.03增加左侧tree固定宽度
  width: 180px;
  display: inline-block;
  // width: 210px;
  .el-role-tree {
    position: absolute;
    padding: 5px 0px;
    top: 45px;
    bottom: 0;
    // border-right: 1px solid #eee;
  }
  .actived {
    color: #5884ff;
    font-size: 15px;
  }
  .action-text {
    font-size: 14px;
  }
}
.role-list {
  color: white;
  line-height: 40px;
  background: #1a89ff;
  padding: 0 13px;
  font-size: 16px;
  position: absolute;
  top: 2px;
  width: 179px;
}
</style>
<style scoped>
.com-el-tree >>> .el-tree-node {
  padding: 3px 0;
}
.com-el-tree >>> .el-scrollbar .el-scrollbar__thumb {
  width: 0 !important;
}
</style>
